#!/usr/bin/env python
# encoding: utf-8
"""
museur.py

Created by Alexandre Korber on 2009-10-16.
Copyright (c) 2009 __petiteboitesansfond__. All rights reserved.
"""

import getUrlsVideos
import os
import time
import random
import string
import sqlite3
import commands
import subprocess
#from threading import Thread
import sys
import randomWord
import db_museur


ytdl_path = "../../src/youtube-dl.py"

"""
Réglages de qualité
"""
#ytdl_options = "-f 18"	# AAC stereo 44100 >10Mo
ytdl_options = "-m"	# AAC mono 22050 < 7Mo

"""
Extentions des fichiers
"""
video_file_ext = ".mp4"
audio_file_ext = ".wav"
"""
Chemins
"""
dl_path = "../../downloads"
url_db = os.getcwd()+"/museur.db"

"""
Réglages du nb de résultats souhaités pour un mot tiré au hasard
"""
resultats = 150
ratio_souhaite = 90	#pourcentage de réussite pour garder le mot


museur_cherche = 1 # Il cherche tout le temps si 1

def museur():
	
	"""
	Fonctionnement : 
	Tant que le museur est en marche (museur_cherche = 1)
		Il tire des mots au hasard et choisis ceux qui donnent le nb de résultats souhaités avec une tolérence (ratio_souhaite)
			Pour le mot sélectionné, il crée un répertoire, télécharge chaque video, extrait l'audio et efface la vidéo.
			OPTION : Il insert une ligne dans une base de donnée (museur.db) : Nécéssite l'usage de sqlite3 installé par défaut sur osx léopard
			
	!!!Nécéssite l'installation de ffmpeg (via macport  : http://www.macports.org/install.php)
	
	"""
	while museur_cherche:
		word = randomWord.randomWord()
		print "-----> mot trouvé : "+word
		nb_url_trouve = len(getUrlsVideos.getUrlsVideos(word, resultats))
		ratio_obtenu = (float(nb_url_trouve)/float(resultats))*100
		print "-----> ratio : "+str(ratio_obtenu)+"%"
		if ratio_obtenu > ratio_souhaite:
 			print "-----> ratio ok : on télécharge"
			os.chdir("../downloads/")
			os.system('mkdir '+word)
			os.chdir(word+'/')
			print "Création du repertoire : "+os.getcwd()
			bug = 0
			result_count = 1
			for i in getUrlsVideos.getUrlsVideos(word, resultats):
				file_name = string.replace(i,"http://www.youtube.com/watch?v=","")
				video_file_path = os.getcwd()+"/"+file_name+video_file_ext
				audio_file_path = os.getcwd()+"/"+file_name+'_'+word+audio_file_ext
				relative_audio_file_path = word+"/"+file_name+'_'+word+audio_file_ext	# Pour la base de donnée
				
				print 'Téléchargement du fichier N°'+str(result_count)+' : '+i+video_file_ext
				download_on_youtube = subprocess.Popen('python '+ytdl_path+' '+ytdl_options+' '+i, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
				out_download, err_download = download_on_youtube.communicate()
				if err_download:
					print "!!!	Erreur de téléchargement = "+err_download
					bug +=1
					print "!!!	Nombre de fichiers non téléchargés = "+str(bug)
				else:
					print 'Extraction du son de '+file_name+video_file_ext
					extract_audio = subprocess.Popen('ffmpeg -i '+file_name+video_file_ext+' -vn -acodec pcm_s16le -ar 44100 -ac 2 '+audio_file_path, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
					out_extract_audio, err_extract_audio = extract_audio.communicate()
					# print "out_extract_audio = "+out_extract_audio
					
					print 'Effacement de '+file_name+video_file_ext
					rm_video = subprocess.Popen('rm '+video_file_path, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
					
					duration = commands.getoutput("ffmpeg -i '"+audio_file_path+"' 2>&1 | grep 'Duration' | cut -d ' ' -f 4 | sed s/,//")
					print "Durée du fichier audio : "+duration
					
					# print "Référencement du fichier dans la base SQLite "
					# db_museur.insert(url_db,relative_audio_file_path,word,duration,0)
													
				print"----------------------------------"
				result_count += 1
			
				
				
	 		os.chdir('../')
		else:
			print "!!!    ratio = "+str(ratio_obtenu)+"% : on abandonne le mot"

if __name__ == '__main__':
	museur()

